Summary:   Open source remote desktop protocol (RDP) server
Name:      xrdp
Version:   0.6.1
Release:   2
License:   GPLv2+ with exceptions
Group:     Applications/Internet
URL:       http://xrdp.sourceforge.net/
Source0:   http://sourceforge.net/projects/xrdp/files/%{name}/%{version}/%{name}-v%{version}.tar.gz
Source1:   %{name}.sysconfig
Source2:   %{name}.logrotate
Source3:   %{name}.aix.init
Source4:   %{name}-sesman.aix.init
Source10:  %{name}-config-aix.patch
Patch0:    %{name}-%{version}-aix.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: autoconf, automake, libtool
BuildRequires: AIX-rpm >= 5.3.7.0
BuildRequires: openssl-devel >= 1.0.1s-1

Requires: AIX-rpm >= 5.3.7.0
Requires: openssl >= 1.0.1s-1
# vnc-server provides Xvnc
Requires: tightvnc-server >= 1.3.10-2

%description
The goal of this project is to provide a fully functional Linux terminal
server, capable of accepting connections from rdesktop and Microsoft's own
terminal server / remote desktop clients.


%prep
%setup -q -n %{name}-v%{version}
%patch0


%build
./bootstrap

export CC="xlc_r"

./configure \
    --prefix=%{_prefix} \
    --sysconfdir=/etc \
    --localstatedir=/var \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-nopam

make %{?smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}
make install DESTDIR=${RPM_BUILD_ROOT}

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :
/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_sbindir}/* || :

# install xrdp sysconfig stuff
mkdir -p ${RPM_BUILD_ROOT}/etc/sysconfig
cp %{SOURCE1} ${RPM_BUILD_ROOT}/etc/sysconfig/%{name}
chmod 0644 ${RPM_BUILD_ROOT}/etc/sysconfig/%{name}

# install xrdp logrotate stuff
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
cp %{SOURCE2} ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}
chmod 0644 ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/%{name}

# install log file /var/log/xrdp-sesman.log
mkdir -p ${RPM_BUILD_ROOT}/var/log
touch ${RPM_BUILD_ROOT}/var/log/xrdp-sesman.log

# rsakeys.ini
touch ${RPM_BUILD_ROOT}/etc/%{name}/rsakeys.ini
chmod 0600 ${RPM_BUILD_ROOT}/etc/%{name}/rsakeys.ini

# create the /etc/rc.d/init.d/ scripts and symlinks
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/init.d/
cp %{SOURCE3} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name}
cp %{SOURCE4} ${RPM_BUILD_ROOT}/etc/rc.d/init.d/%{name}-sesman
chmod 0755 ${RPM_BUILD_ROOT}/etc/rc.d/init.d/*

mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/
mkdir -p ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/
ln -sf '../init.d/xrdp' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/S%{name}
ln -sf '../init.d/xrdp' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/K%{name}
ln -sf '../init.d/xrdp' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/S%{name}
ln -sf '../init.d/xrdp' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/K%{name}
ln -sf '../init.d/xrdp-sesman' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/S%{name}-sesman
ln -sf '../init.d/xrdp-sesman' ${RPM_BUILD_ROOT}/etc/rc.d/rc2.d/K%{name}-sesman
ln -sf '../init.d/xrdp-sesman' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/S%{name}-sesman
ln -sf '../init.d/xrdp-sesman' ${RPM_BUILD_ROOT}/etc/rc.d/rc3.d/K%{name}-sesman

cd ${RPM_BUILD_ROOT}%{_libdir}/%{name}
for i in rdp vnc xup ; do
  /usr/bin/ar -x lib${i}.a
  ln -s lib${i}.so.0 lib${i}.so
done

cd ${RPM_BUILD_ROOT}/etc/%{name}
patch -s < %{SOURCE10}


%post
if [ $1 -eq 1 ] ; then 
    /etc/rc.d/init.d/xrdp condrestart >/dev/null 2>&1 || :
    /etc/rc.d/init.d/xrdp-sesman condrestart >/dev/null 2>&1 || :
fi


%preun
if [ $1 -eq 0 ] ; then
# Package removal, not upgrade
    /etc/rc.d/init.d/xrdp stop >/dev/null 2>&1 || :
    /etc/rc.d/init.d/xrdp-sesman stop >/dev/null 2>&1 || :
fi


%postun
if [ $1 -ge 1 ] ; then
# Package upgrade, not uninstall
    /etc/rc.d/init.d/xrdp restart >/dev/null 2>&1 || :
    /etc/rc.d/init.d/xrdp-sesman restart >/dev/null 2>&1 || :
fi


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%doc COPYING *.txt
%dir /etc/%{name}
%config(noreplace) /etc/%{name}/sesman.ini
%config(noreplace) /etc/%{name}/%{name}.ini
%config(noreplace) /etc/%{name}/startwm.sh
%config(noreplace) %{_sysconfdir}/logrotate.d/%{name}
%config(noreplace) /etc/sysconfig/%{name}
/etc/%{name}/%{name}.sh
/etc/%{name}/km*.ini
%{_bindir}/*
%{_sbindir}/*
%{_libdir}/%{name}
%{_datadir}/%{name}
%{_mandir}/man5/*
%{_mandir}/man8/*
/etc/rc.d/init.d/%{name}
/etc/rc.d/rc2.d/S%{name}
/etc/rc.d/rc2.d/K%{name}
/etc/rc.d/rc3.d/S%{name}
/etc/rc.d/rc3.d/K%{name}
/etc/rc.d/init.d/%{name}-sesman
/etc/rc.d/rc2.d/S%{name}-sesman
/etc/rc.d/rc2.d/K%{name}-sesman
/etc/rc.d/rc3.d/S%{name}-sesman
/etc/rc.d/rc3.d/K%{name}-sesman

%ghost /var/log/xrdp-sesman.log
%attr(0600,root,system) %verify(not size md5 mtime) /etc/%{name}/rsakeys.ini


%changelog
* Fri Mar 04 2016 Michael Perzl <michael@perzl.org> - 0.6.1-2
- recompiled against latest version of openssl

* Thu Feb 06 2014 Michael Perzl <michael@perzl.org> - 0.6.1-1
- first version for AIX V6.1 and higher
